# Cambia "dogmole" por el nombre de tu güego y pantallas por el número de pantallas.
nombre=sami
pantallas=24

function script {
	echo -e "\e[32Compilando script\e[0m"
	wine ../scripts/msc.exe ../scripts/$name.spt msc.h $PANTALLAS
}

function color {
	echo -e "\e[32Ajustando colores\e[0m"
	../utils/posterizezx ../gfx/title.png ../gfx/title.png
	../utils/posterizezx ../gfx/ending.png ../gfx/ending.png
	../utils/posterizezx ../gfx/loading.png ../gfx/loading.png
	../utils/posterizezx ../gfx/work.png ../gfx/work.png
}

function pantalla {
	echo -e "\e[32mComprimiendo las pantallas\e[0m"
	../utils/png2rcs ../gfx/title.png ../gfx/title.rcs
	../utils/png2rcs ../gfx/ending.png ../gfx/ending.rcs
	../utils/png2rcs ../gfx/loading.png ../gfx/loading.rcs
	rm title.bin ending.bin loading.bin loading.scr
	../utils/rcs -d ../gfx/loading.rcs loading.scr
	../utils/zx7 ../gfx/title.rcs title.bin
	../utils/zx7 ../gfx/ending.rcs ending.bin
	../utils/zx7 ../gfx/loading.rcs loading.bin
}

function mapa {
	echo -e "\e[32mGenerando mapa y graficos\e[0m"
  ../utils/tmxcompress ../map/samitroid.tmx mapa_comprimido.bin
  ../utils/gfxcnv ../gfx/chars.png ../gfx/work.png ../gfx/spriteset.png tileset.h sprites.h
  ../utils/tmxcnv ../map/samitroid.tmx mapa.h enems.h
}

function compilar {
	zcc +zx -vn $nombre.c -o $nombre.bin -lndos -lsplib2 -zorg=24200
}

function juego {
	../utils/bas2bin loader.bas
	../utils/gentape $nombre.tap \
	basic "'$nombre'" 10 loader.bin \
	hdata "'SCREEN'" 4000 loading.scr \
	hdata "'DZX7'"   5d44 dzx7.bin    \
	hdata "'GUEGO'"  5e88 $nombre.bin
}

function generate {
	../utils/sjasmplus asmloader.asm
	../utils/gentape $nombre.tap \
      basic "'$nombre'"  0 asmloader.bin \
      data                $nombre.zx7
}

function prod {
	echo -e "\e[32mComprimiendo el juego\e[0m"
	rm $nombre.zx7
	../utils/zx7 $nombre.bin $nombre.zx7
	filesize=$(du -b $nombre.zx7 | cut -d ' ' -f1)
	echo " define COMP_SIZE $filesize" > define.asm
}

function ayuda {
	echo "Compilador de la Churrera"
	echo '(c) 2013 Alfonso Saavedra "Son Link"'
	echo 'Script original por Antonio Villena'
	echo "Compila tu juego o prepara algunos de las partes"
	echo " "
	echo "Opciones:"
	echo "-h, --help			muestra esta ayuda"
	echo "-c, --color			comprueba los colores de las imágenes"
	echo "-s, --script			compila el scripting"
	echo "-m, --mapa			Prepara el mapeado del juego"
	echo "-j, --juego, sin parametros	compila el juego."
	echo "-pr, --produced			Compila el juego en una versión comprimida"
	exit 0
}

if [ $# == 1 ]; then
	case "$1" in
		-s|--script)
			script
			;;
		-c|--color)
			color
			;;
		-p|--pantalla)
			pantalla
			;;

		-m|--mapa)
			mapa
			;;
		-pr|--produced)
			compilar
			prod
			generate
			;;
		-j|--juego)
			compilar
			juego
			;;
		*)
			ayuda
			;;
	esac
else
	if [ $# == 0 ]; then
		compilar
		juego
	else
		ayuda
	fi
fi
