#!/bin/bash
NAME=sami
echo -e "\e[32mCompilando $NAME"
#cd ../map
#mapcnv mapa.map 2 2 15 10 15 packed
#cp mapa.h ../dev
echo -e "\e[32Compilando script\e[0m"
cd ../script
wine msc.exe $NAME.spt msc.h 24

cp *.h ../dev
cd ../dev
echo -e "\e[32mComprimiendo las pantallas\e[0m"
../utils/posterizezx ../gfx/title.png ../gfx/titlep.png
../utils/posterizezx ../gfx/ending.png ../gfx/endingp.png
../utils/png2rcs ../gfx/titlep.png ../gfx/title.rcs
../utils/png2rcs ../gfx/endingp.png ../gfx/ending.rcs
rm title.bin ending.bin
../utils/zx7 ../gfx/title.rcs title.bin
../utils/zx7 ../gfx/ending.rcs ending.bin

echo -e "\e[32mRegenrando mapas\e[0m"
../utils/tmxcompress ../map/samitroid.tmx mapa_comprimido.bin
../utils/posterizezx ../gfx/work.png ../gfx/work2.png
../utils/posterizezx ../gfx/sprites.png ../gfx/sprites2.png
../utils/gfxconv ../gfx/fuente-base.png ../gfx/work2.png ../gfx/sprites2.png tileset.h sprites.h
../utils/tmxcnv ../map/samitroid.tmx mapa.h

echo -e "\e[32mCompilando juego\e[0m"
#sprcnv ../gfx/sprites.png sprites.h
zcc +zx -vn $NAME.c -o $NAME.bin -lndos -lsplib2 -zorg=24200
echo -e "\e[32mCreando la cinta\e[0m"
../utils/bas2bin loader.bas
../utils/gentape sami.tap 	\
	basic "'SAMI'"  10  loader.bin 		\
	hdata "'SCREEN'"  4000  loading.bin \
	hdata "'JUEGO'" 5e88  sami.bin
#bin2tap -o screen.tap -a 16384 loading.bin
#bin2tap -o main.tap -a 25000 $NAME.bin
#cat loader.tap screen.tap main.tap > $NAME.tap

echo -e "\e[32mCompilación terminada.\e[0m"

# Si tienes instalado las herramientas del emulador fuse, descomenta las siguientes lineas para
# saber de cuanto espacio libre dispones.
echo -e "\e[32mCalculando espacio disponible\e[0m"
TAMANO=`tzxlist main.tap | grep "Data length" | tail -1 | grep -o '[0-9]*'`
TOTAL=`expr $TAMANO + 24200`
ZXWEIGHT=`expr 60654 - $TOTAL`
echo "$TAMANO + 24200 = $TOTAL ( $ZXWEIGHT )"

echo -e "\e[32mLimpiando\e[0m"
rm loader.tap
rm screen.tap
rm main.tap
rm $NAME.bin
